=== debian/changelog ===
deal.ii (9.7.1-4) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * d/watch: version=5
  * Remove libboost-system-dev from Build-Depends
    Closes: #1127187

  [ Francesco Ballarin ]
  * Standards-Version: 4.7.3
  * Drop unnecessary Priority and Rules-Requires-Root fields from d/control
  * Add patch drop-w3c-validator.patch to drop W3C validation icons. Fixes
    lintian error privacy-breach-w3c-valid-html
  * Add more examples to remove-iframes-from-documentation.patch. Fixes lintian
    warning privacy-breach-generic.
  * Remove libboost-system-dev from libdeal.ii-dev dependencies

 -- Francesco Ballarin <ballarin@debian.org>  Tue, 24 Feb 2026 17:13:20 +0000

deal.ii (9.7.1-3) unstable; urgency=medium

  [ Dandan Zhang ]
  * Fix relocation R_LARCH_B26 overflow for loong64
    (Closes: #1120656)

  [ Graham Inggs ]
  * Reinstate mold build dependency on amd64, arm64 and riscv64

 -- Graham Inggs <ginggs@debian.org>  Thu, 12 Feb 2026 17:34:54 +0000

deal.ii (9.7.1-2) unstable; urgency=medium

  * Drop unnecessary versioned dependencies on
    libocct-data-exchange-dev
  * Drop build and test dependencies on mold, but
    leave as a Recommends for now
  * Disable setup_sanity_checks, which has
    an issue with ld.bfd
  * Do not run setup_tests_quick_tests in parallel
  * Work around setup_tests_quick_tests ignoring -j1

 -- Graham Inggs <ginggs@debian.org>  Tue, 30 Dec 2025 18:45:23 +0000

deal.ii (9.7.1-1) unstable; urgency=medium

  * New upstream release
  * update debian files and patches

 -- Matthias Maier <tamiko+DEBIAN@43-1.org>  Wed, 26 Nov 2025 10:29:04 +0000
